precision highp float;
attribute vec4 position;
attribute vec4 normal;
varying vec2 texcoordVarying;
varying vec4 diffuseVarying;
uniform mat4 mvp;
uniform vec4 pixelRotation;

//xy: pixel translation, zw : pixelScale
uniform vec4 pixelTranslationScale;

//xy: postPixelTranslation, zw : scale
uniform vec4 postPixelTranslation;

uniform vec4 viewport;

vec3 rotate_vector( vec4 quat, vec3 vec )
{
	return vec + 2.0 * cross( cross( vec, quat.xyz ) + quat.w * vec, quat.xyz );
}

void main()
{
	texcoordVarying = normal.zw;
	diffuseVarying = vec4( 1.0, 1.0, 1.0, position.w );

	// calculates labelcenter position
    vec4 currentPosition = vec4( position.xyz, 1.0 );
	currentPosition = mvp * currentPosition;
	currentPosition /= currentPosition.w;
	
	// calculates ndc space labelposition
	vec3 translation = rotate_vector( pixelRotation, vec3( normal.xy, 0.0) );
	translation.xy *= pixelTranslationScale.zw;
    
    translation += rotate_vector( pixelRotation, vec3( pixelTranslationScale.xy, 0.0 ) );
    
//    translation.xy *= postPixelTranslation.zw;
    translation.xy += postPixelTranslation.xy;
	
	gl_Position.x = currentPosition.x + ( (translation.x ) / viewport.z ) * 2.0;
	gl_Position.y = currentPosition.y - ( (translation.y ) / viewport.w ) * 2.0;
    gl_Position.zw = currentPosition.zw;
}
